package com.muyu.cloud.etl.controller;

import com.dtflys.forest.annotation.NotNull;
import com.muyu.cloud.etl.service.StructureService;
import com.muyu.cloud.etl.service.TableInfoService;
import com.muyu.common.core.domain.Result;
import com.muyu.domain.Structure;
import com.muyu.domain.TableInfo;
import com.muyu.domain.rep.TableInfoResp;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("/tableInfo")
public class TableInfoController {
    @Autowired
    private TableInfoService tableInfoService;
    @Autowired
    private StructureService structureService;

//    @GetMapping("/findTableInfo")
//    public Result<List<TableInfoTreeRep>> findTableInfo() {
//          List<TableInfo> tableInfoList= tableInfoService.findSourceList();
//
//        List<TableInfoTreeRep> tableInfoTreeReps = new ArrayList<TableInfoTreeRep>();
//
//        for (TableInfo tableInfo : tableInfoList) {
//            TableInfoTreeRep tableInfoTreeRep = new TableInfoTreeRep();
//            tableInfoTreeRep.setTableInfo(tableInfo);
//            List<TableInfoRep> tableInfoRepList=  tableInfoService.findTablesList(tableInfo.getId());
//            tableInfoTreeRep.setChildren(tableInfoRepList);
//            for (TableInfoRep tableInfoRep : tableInfoRepList) {
//                List<Structure> structureList=structureService.findStructureList(tableInfoRep.getId());
//                tableInfoRep.setStructureList(structureList);
//            }
//            tableInfoTreeReps.add(tableInfoTreeRep);
//        }
//
//        return Result.success(tableInfoTreeReps);
//
//    }

    @GetMapping("/findTableInfoList")
    public Result findByTableName() {
        List<TableInfo> list = tableInfoService.list();
        List<TableInfoResp> respList = list.stream().filter(tableInfo -> tableInfo.getParentId()==0).map(tableInfo -> {
            TableInfoResp tableInfoResp = TableInfo.toTableInfoResp(tableInfo);
            tableInfoResp.setChildren(getChildren(tableInfo, list));
            return tableInfoResp;
        }).toList();
        return Result.success(respList);
    }



    @NotNull
    private static List<TableInfoResp> getChildren(TableInfo tableInfo, List<TableInfo> list) {
        return list.stream().filter(tableInfo1 -> tableInfo1.getParentId().equals(tableInfo.getId())).map(
                tableInfo2 -> TableInfo.toTableInfoResp(tableInfo2)
        ).toList();
    }

    @GetMapping("/findStruceure/{id}")
    public Result<List<Structure>> findStruceure(@PathVariable("id") Integer id) {
     List<Structure> structureList=   structureService.findStructurelistS(id);
     return Result.success(structureList);
    }

}
